*** Settings ***
Documentation  处理activeMQ的关键字文件, 引用请使用Resource atApiBasicLibray/keywords/[ sc/activemq.html | activemq.robot]
Library   ../activemqLib.py

*** Keywords ***
ActiveMQ发送消息
    [Documentation]  通过stomp协议向activeMQ发送消息。第一个参数${query或者topic},string类型。activeMQ的队列名或者主题名。
    ...    第二个参数${消息}，string类型。需要发送的消息。第三个参数${activeMQ地址}，string类型,activeMQ的域名或者IP地址。
    ...    可选参数${activeMQ端口}，int类型, activeMQ stomp端口,注意是stomp协议端口，默认值是61613。
    ...    可选参数${broker用户名}，string类型。activeMQ的broker用户名。默认值是None。
    ...    可选参数${broker密码}，string类型。activeMQ的broker的密码。
    [Arguments]      ${query或者topic}    ${消息}   ${activeMQ地址}   ${activeMQ端口}=${61613}   ${broker用户名}=${None}   ${broker密码}=${None}
    send to queue    ${query或者topic}    ${消息}   ${activeMQ地址}   port=${activeMQ端口}       username=${broker用户名}  password=${broker密码}

ActiveMQ Publish Message
    [Documentation]  通过stomp协议向activeMQ发送消息。第一个参数${query or topic},string类型。activeMQ的队列名或者主题名。
    ...    第二个参数${msg}，string类型。需要发送的消息。第三个参数${host}，string类型,activeMQ的域名或者IP地址。
    ...    可选参数${port}，int类型, activeMQ stomp端口,注意是stomp协议端口，默认值是61613。
    ...    可选参数${username}，string类型。activeMQ的broker用户名。默认值是None。注意不是jetty的用户。
    ...    可选参数${password}，string类型。activeMQ的broker的密码。默认值是None。注意不是jetty的密码。
    [Arguments]      ${query or topic}    ${msg}   ${host}   ${port}=${61613}   ${username}=${None}   ${password}=${None}
    send to queue    ${query or topic}    ${msg}   ${host}   port=${port}       username=${username}  password=${password}