*** Settings ***
Documentation  处理http request的关键字文件。引用请使用Resource  atBasicLibray/keywords/request.robot  [ sc/request.html | request.robot ]
Library  ../requestLib.py

*** Keywords ***
Get请求
    [Documentation]  功能:GET请求。返回封装好的request和response的字典。返回:
    ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...         英文关键字[ ../keywords/request.doc.html#Get%20request | Get request ]。
    ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数【timeout】，
    ...         设置timeout时间，单位是秒。例子：  Get请求   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}   45.
    ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Get | at_http_get] 方法。
    [Arguments]             ${uri}    ${params}=${None}   ${headers}=${None}    ${timeout}=${None}
    ${resp}=  at http get   ${uri}    params=${params}    headers=${headers}    timeout=${timeout}
    [Return]  ${resp}

Get request
    [Documentation]  功能:GET请求。返回封装好的request和response的字典。返回:
    ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...         中文关键字[ ../keywords/request.doc.html#Get请求 | Get请求 ]。
    ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数【timeout】，
    ...         设置timeout时间，单位是秒。例子：  Get request   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}   45.
    ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Get | at_http_get] 方法。
    [Arguments]             ${uri}    ${params}=${None}   ${headers}=${None}   ${timeout}=${None}
    ${resp}=  at http get   ${uri}    params=${params}   headers=${headers}    timeout=${timeout}
    [Return]  ${resp}

Post请求
    [Documentation]   功能:POST请求。返回封装好的request和response的字典。返回:
    ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...         英文关键字[ ../keywords/request.doc.html#Post%20request | Post request ]。
    ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数是【body】,String类型。
    ...         第五个参数【timeout】，设置timeout时间，单位是秒。例子：  Post请求   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}  bodyStr  45.
    ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Post | at_http_post] 方法。
    [Arguments]             ${uri}        ${params}=${None}   ${headers}=${None}     ${body}=${None}   ${timeout}=${None}
    ${resp}=  at http post  ${uri}        params=${params}    headers=${headers}     body=${body}      timeout=${timeout}
    [Return]  ${resp}

Post request
     [Documentation]    功能:POST请求。返回封装好的request和response的字典。返回:
    ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...         中文关键字[ ../keywords/request.doc.html#Post请求 | Post请求 ]。
    ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数是【body】,String类型。
    ...         第五个参数【timeout】，设置timeout时间，单位是秒。例子：  Post request   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}  bodyStr  45.
    ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Post | at_http_post] 方法。
    [Arguments]             ${uri}        ${params}=${None}   ${headers}=${None}     ${body}=${None}   ${timeout}=${None}
    ${resp}=  at http post  ${uri}        params=${params}    headers=${headers}      body=${body}      timeout=${timeout}
    [Return]  ${resp}

Post Json请求
    [Documentation]  功能:POST json 请求。返回封装好的request和response的字典。返回:
     ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
     ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
     ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
     ...         英文关键字[ ../keywords/request.doc.html#Post%20json%20request | Post json request ]。
     ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数是【json】,String类型或者字典类型都支持。
     ...         第五个参数【timeout】，设置timeout时间，单位是秒。例子：  Post Json请求   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}  {"mm":True,"nn":123}  45.
     ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Post%20Json | at_http_post_json] 方法。
    [Arguments]                  ${url}    ${params}=${None}   ${headers}=${None}    ${json}=${None}   ${timeout}=${None}
    ${resp}=  at http post json  ${url}    params=${params}   headers=${headers}     json=${json}    timeout=${timeout}
    [Return]  ${resp}

Post json request
    [Documentation]  功能:POST json 请求。返回封装好的request和response的字典。返回:
     ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
     ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
     ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
     ...         中文关键字[ ../keywords/request.doc.html#Post%20Json请求 | Post Json请求 ]。
     ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数是【json】,String类型或者字典类型都支持。
     ...         第五个参数【timeout】，设置timeout时间，单位是秒。例子：  Post json request   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}  {"mm":True,"nn":123}  45.
     ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Post%20Json | at_http_post_json] 方法。
     [Arguments]                 ${url}    ${params}=${None}   ${headers}=${None}    ${json}=${None}   ${timeout}=${None}
    ${resp}=  at http post json  ${url}    params=${params}    headers=${headers}     json=${json}     timeout=${timeout}
    [Return]  ${resp}

Put请求
    [Documentation]  功能:PUT请求。返回封装好的request和response的字典。返回:
    ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...         英文关键字[ ../keywords/request.doc.html#Put%20request  | Put request ]。
    ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数是【body】,String类型。
    ...         第五个参数【timeout】，设置timeout时间，单位是秒。例子：  Put请求   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}  bodyStr  45.
    ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Put | at_http_put] 方法。
    [Arguments]            ${uri}       ${params}=${None}   ${headers}=${None}     ${body}=${None}    ${timeout}=${None}
    ${resp}=  at http put  ${uri}       params=${params}    headers=${headers}     body=${body}       timeout=${timeout}
    [Return]  ${resp}

Put request
    [Documentation]  功能:PUT请求。返回封装好的request和response的字典。返回:
    ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...         中文关键字[ ../keywords/request.doc.html#Put%20request  | Put请求 ]。
    ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数是【body】,String类型。
    ...         第五个参数【timeout】，设置timeout时间，单位是秒。例子：  Put request   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}  bodyStr  45.
    ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Put | at_http_put] 方法。
    [Arguments]            ${uri}       ${params}=${None}   ${headers}=${None}     ${body}=${None}    ${timeout}=${None}
    ${resp}=  at http put  ${uri}       params=${params}    headers=${headers}     body=${body}       timeout=${timeout}
    [Return]  ${resp}

Put Json请求
    [Documentation]   功能:PUT json请求。返回封装好的request和response的字典。返回:
     ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
     ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
     ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }
     ...         英文关键字[ ../keywords/request.doc.html#Put%20json%20request  | Put json request]。
     ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数是【json】,String类型或者字典类型都支持。
     ...         第五个参数【timeout】，设置timeout时间，单位是秒。例子：  Put Json请求   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}  {"mm":True,"nn":123}  45.
     ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#Http%20Json%20Put | at_http_put_json] 方法。
    [Arguments]                 ${url}    ${params}=${None}  ${headers}=${None}    ${json}=${None}   ${timeout}=${None}
    ${resp}=  at http put json  ${url}    params=${params}   headers=${headers}     json=${json}     timeout=${timeout}
    [Return]  ${resp}

Put json request
    [Documentation]  功能:PUT json请求。返回封装好的request和response的字典。返回:
     ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
     ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
     ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }
     ...         中文关键字[ ../keywords/request.doc.html#Put%20Json请求  | Put Json请求]。
     ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数是【json】,String类型或者字典类型都支持。
     ...         第五个参数【timeout】，设置timeout时间，单位是秒。例子：  Put json request   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}  {"mm":True,"nn":123}  45.
     ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#Http%20Json%20Put | at_http_put_json] 方法。
    [Arguments]                 ${url}    ${params}=${None}  ${headers}=${None}    ${json}=${None}   ${timeout}=${None}
    ${resp}=  at http put json  ${url}    params=${params}   headers=${headers}     json=${json}    timeout=${timeout}
    [Return]  ${resp}

Delete请求
    [Documentation]  功能:DELETE请求。返回封装好的request和response的字典。返回:
    ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }
    ...         英文关键字[ ../keywords/request.doc.html#Delete%20request  | Delete request]。
    ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数【timeout】，
    ...         设置timeout时间，单位是秒。例子：  Delete请求   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}   45.
    ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Delete | at_http_delete] 方法。
    [Arguments]                ${uri}        ${params}=${None}     ${headers}=${None}    ${timeout}=${None}
    ${resp}=  at http delete   ${uri}        params=${params}      headers=${headers}    timeout=${timeout}
    [Return]  ${resp}

Delete request
    [Documentation]  功能:DELETE请求。返回封装好的request和response的字典。返回:
    ...         { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...         "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...         "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }
    ...         中文关键字[ ../keywords/request.doc.html#Delete请求  | Delete请求]。
    ...         第一个参数是【uri】，请求的uri，String类型。第二个参数是【params】，请求的parameters，字典类型。第三个参数【headers】,请求的头，字典类型。第四个参数【timeout】，
    ...         设置timeout时间，单位是秒。例子：  Delete request   http://localhost:8080/aaa/bb   {"aa":"dsada","bb":"3213"}     {"token:"dada"}   45.
    ...         具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Delete | at_http_delete] 方法。
    [Arguments]                ${uri}        ${params}=${None}     ${headers}=${None}    ${timeout}=${None}
    ${resp}=  at http delete   ${uri}        params=${params}      headers=${headers}    timeout=${timeout}
    [Return]  ${resp}

Post上传文件
    [Documentation]  功能:上传文件。
    ...          英文关键字[ ../keywords/request.doc.html#Post%20upload%20files  | Post upload files]。
    ...          第一个参数是【uri】，请求的uri，String类型。
    ...          第二个参数是【files】，请求中的文件，字典类型。比如{"文件路径，可以是相对路径也可以是绝对路径":"请求中的request name"}。
    ...          第三个参数是【params】，请求的parameters，字典类型。第四个参数【headers】,请求的头，字典类型。
    ...          第五个参数【timeout】,设置timeout时间，单位是秒。
    ...          例子：Post上传文件  http://localhost:8080/aaa/bb   {"/aa/bb.txt":"avatar","../cc/dd.txt":"avatar"} {"aa":"dsada","bb":"3213"}   {"token:"dada"}  45.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Post%20Files | at http post files] 方法。
    [Arguments]                   ${uri}  ${files}        ${params}=${None}   ${headers}=${None}    ${timeout}=${None}
    ${resp}=  at http post files  ${uri}  ${files}        params=${params}    headers=${headers}    timeout=${timeout}
    [Return]  ${resp}

Post upload files
    [Documentation]  功能:上传文件。
    ...          中文关键字[ ../keywords/request.doc.html#Post上传文件  | Post上传文件]。
    ...          第一个参数是【uri】，请求的uri，String类型。
    ...          第二个参数是【files】，请求中的文件，字典类型。比如{"文件路径，可以是相对路径也可以是绝对路径":"请求中的request name"}。
    ...          第三个参数是【params】，请求的parameters，字典类型。第四个参数【headers】,请求的头，字典类型。
    ...          第五个参数【timeout】,设置timeout时间，单位是秒。
    ...          例子：Post upload files  http://localhost:8080/aaa/bb   {"/aa/bb.txt":"avatar","../cc/dd.txt":"avatar"} {"aa":"dsada","bb":"3213"}   {"token:"dada"}  45.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Post%20Files | at http post files] 方法。
    [Arguments]                   ${uri}  ${files}        ${params}=${None}   ${headers}=${None}    ${timeout}=${None}
    ${resp}=  at http post files  ${uri}  ${files}        params=${params}    headers=${headers}    timeout=${timeout}
    [Return]  ${resp}

发送Request
    [Documentation]  功能:request通用方法。
    ...          英文关键字[ ../keywords/request.doc.html#Send%20request  | Send request ]。
    ...          如何使用请参考requests包request的API。
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Request | at_http_request] 方法。
    [Arguments]                 ${method}    ${url}    ${params}=${None}   ${headers}=${None}    ${data}=${None}     ${json}=${None}       ${cookies}=${None}     ${files}=${None}        ${auth}=${None}         ${allow_redirects}=${None}           ${proxies}=${None}    ${verify}=${None}  ${stream}=${None}       ${cert}=${None}
    ${resp}=  at http request   ${method}    ${url}    params=${params}    headers=${headers}    data=${data}        json=${json}          cookies=${cookies}     files=${files}          auth=${auth}            allow_redirects=${allow_redirects}   proxies=${proxies}    verify=${verify}   stream=${stream}        cert=${cert}
    [Return]  ${resp}

Send request
    [Documentation]  功能:request通用方法。
    ...          中文关键字[ ../keywords/request.doc.html#发送Request  | 发送Request ]。
    ...          如何使用请参考requests包request的API。
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Http%20Request | at_http_request] 方法。
    [Arguments]                 ${method}    ${url}    ${params}=${None}   ${headers}=${None}    ${data}=${None}     ${json}=${None}       ${cookies}=${None}    ${files}=${None}        ${auth}=${None}         ${allow_redirects}=${None}           ${proxies}=${None}    ${verify}=${None}  ${stream}=${None}       ${cert}=${None}
    ${resp}=  at http request   ${method}    ${url}    params=${params}    headers=${headers}    data=${data}        json=${json}          cookies=${cookies}    files=${files}          auth=${auth}            allow_redirects=${allow_redirects}   proxies=${proxies}    verify=${verify}   stream=${stream}        cert=${cert}
    [Return]  ${resp}

获得response header
    [Documentation]  功能:通过Response获得response header.
    ...          英文关键字[ ../keywords/request.doc.html#Get%20response%20header  | Get response header ]。
    ...          参数是框架自定义的response字典类型。获得response header,字典类型.
    ...          { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...          "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...          "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Get%20Http%20Response%20Header |  at_get_http_response_header] 方法
    [Arguments]                                ${response}
    ${header}=  at get http response header    ${response}
    [Return]   ${header}

Get response header
    [Documentation]  功能:通过Response获得response header.
    ...          中文关键字[ ../keywords/request.doc.html#获得response header  | 获得response header ]。
    ...          参数是框架自定义的response字典类型。获得response header,字典类型.
    ...          { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...          "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...          "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Get%20Http%20Response%20Header |  at_get_http_response_header] 方法
    [Arguments]                                ${response}
    ${header}=  at get http response header    ${response}
    [Return]   ${header}

获得response status code
    [Documentation]  功能:通过Response获得response status code.
    ...          英文关键字[ ../keywords/request.doc.html#Get%20response%20status%20code  | Get response status code ]。
    ...          参数是框架自定义的response字典类型。获得response status code,Int类型.
    ...          { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...          "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...          "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Get%20Http%20Response%20Status%20Code |  at_get_http_response_status_code] 方法
    [Arguments]                                          ${response}
    ${status_code}=  at get http response status code    ${response}
    [Return]   ${status_code}

Get response status code
    [Documentation]  功能:通过Response获得response status code.
    ...          中文关键字[ ../keywords/request.doc.html#获得response%20status%20code  | 获得response status code ]。
    ...          参数是框架自定义的response字典类型。获得response status code,Int类型.
    ...          { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...          "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...          "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Get%20Http%20Response%20Status%20Code |  at_get_http_response_status_code] 方法
    [Arguments]                                          ${response}
    ${status_code}=  at get http response status code    ${response}
    [Return]   ${status_code}

获得response body
    [Documentation]  功能:通过Response获得response body.
    ...          英文关键字[ ../keywords/request.doc.html#Get%20response%20body  | Get response body ]。
    ...          参数是框架自定义的response字典类型。获得response body,String类型.
    ...          { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...          "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...          "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Get%20Http%20Response%20Body |  at_get_http_response_body] 方法
    [Arguments]                            ${response}
    ${body}=  at get http response body    ${response}
    [Return]   ${body}

Get response body
    [Documentation]  功能:通过Response获得response body.
    ...          中文关键字[ ../keywords/request.doc.html#获得response%20body  | 获得response body]。
    ...          参数是框架自定义的response字典类型。获得response body,String类型.
    ...          { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...          "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...          "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Get%20Http%20Response%20Body |  at_get_http_response_body] 方法
    [Arguments]                            ${response}
    ${body}=  at get http response body    ${response}
    [Return]   ${body}

获得Response json body
    [Documentation]  功能:通过Response获得response body,返回类型是字典.
    ...          英文关键字[ ../keywords/request.doc.html#Get%20response%20json%20body  | Get response json body]。
    ...          参数是框架自定义的response字典类型。获得response body,字典类型.
    ...          { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...          "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...          "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Get%20Http%20Response%20Json%20Body |  at_get_http_response_json_body] 方法
    [Arguments]                                 ${response}
    ${body}=  at get http response json body    ${response}
    [Return]   ${body}

Get response json body
    [Documentation]  功能:通过Response获得response body,返回类型是字典.
    ...          中文关键字[ ../keywords/request.doc.html#获得Response%20json%20body | 获得Response json body]。
    ...          参数是框架自定义的response字典类型。获得response body,字典类型.
    ...          { "req":{ "header":<请求header,字典类型>, "body":<请求body, String类型，注意本方法不支持GET和DELETE传BODY>,"uri":<uri String类型，含被转义的字符>,
    ...          "method":"<GET/POST/PUT/DELETE>","params":"<Query parameters,就是?之后的key=value,代码会来帮你转义,其他不用管>"},
    ...          "resp":{ "header":<返回的header,字典类型>, "status_code":<返回的status code,整型>，"body":"<返回的body,String类型>"} }.
    ...          具体代码请参考atBasicLibrary/requestLib.py的 [../library/requestLib.py.doc.html#At%20Get%20Http%20Response%20Json%20Body |  at_get_http_response_json_body] 方法
    [Arguments]                                 ${response}
    ${body}=  at get http response json body    ${response}
    [Return]   ${body}