*** Settings ***
Documentation  处理一些常规方法的关键字文件。引用请使用Resource  atBasicLibray/keywords/supper.robot  [ sc/supper.html | supper.robot ]
Library  ../supper.py

*** Keywords ***
超级Http接口验证
    [Documentation]  包含发送http请求以及简单验证的关键字,暂时不支持上传文件的multipart/form-data和x-www-form-urlencoded。
    ...         第一个参数${http方法},目前只支持get,post,put,delete,不区分大小写,string类型，必填字段。
    ...         第二个参数是${请求地址},string类型,必填字段。
    ...         可选参数${请求查询参数},字典类型，或者可以转成字典的String类型。默认是None。
    ...         可选参数${请求body},string类型。请求body当string处理,这个不要和${请求json body}一起用。默认是None。
    ...         可选参数${请求json body},字典类型，或者可以转成字典的String类型。当json处理,这个不要和${请求body}一起用。默认是None。
    ...         可选参数${请求headers},字典类型，或者可以转成字典的String类型。请求头。默认是None。
    ...         可选参数${timeout},int类型,过期时间，单位是秒。默认是None。
    ...         可选参数${重定向},bool类型,是否支持重定向。默认是None,如果是None，返回重定向后的结果。
    ...         可选参数${期待的status code},int类型。期待的返回status code等于其本身值。默认是None,如果是None，不校验。
    ...         可选参数${期待的headers包含},字典类型，或者可以转成字典的String类型。期待的返回headers包含其本身。默认是None,如果是None，不校验。
    ...         可选参数${期待的json body},json类型，或者可以转成json的String类型。期待返回的response json body与其校验相同,默认是None,如果是None，不校验。
    ...         可选参数${期待的body},string类型。期待返回的response body与之校验完全相同,默认是None,如果是None，不校验。
    ...         可选参数${期待的json body包含},json类型，或者可以转成json的String类型。期待返回的json body包含其本身,默认是None,如果是None，不校验。
    ...         可选参数${期待的body包含},string类型。期待返回的response body包含其本身,默认是None,如果是None，不校验。
    ...         可选参数${期待的json body正则匹配包含},字典类型,验证response json body的jsonpath下某个值正则匹配，key是jsonpath,value是正则匹配的规则。比如{"$.aa.0.bb":"\d+"}
    ...         可选参数${期待的body正则匹配包含},string类型, 验证response body正则匹配包含。
    ...         可选参数${期待的json body特殊包含},json类型，或者可以转成json的String类型。默认是None,如果是None，不校验。和${期待的json body包含}相比，不同的是针对数组是无序比较包含，目前不支持嵌套数组包含。
    ...         返回response,字典类型。
    [Arguments]   ${http方法}  ${请求地址}  ${请求查询参数}=${None}   ${请求body}=${None}   ${请求json body}=${None}
    ...      ${请求headers}=${None}   ${timeout}=${None}   ${重定向}=${None}   ${期待的status code}=${None}
    ...      ${期待的headers包含}=${None}  ${期待的json body}=${None}   ${期待的body}=${None}
    ...      ${期待的json body包含}=${None}    ${期待的body包含}=${None}
    ...      ${期待的json body正则匹配包含}=${None}
    ...      ${期待的body正则匹配包含}=${None}
    ...      ${期待的json body特殊包含}=${None}
    ${resp}=  at one http interface test  ${http方法}   ${请求地址}  params=${请求查询参数}  data=${请求body}
    ...     req_json=${请求json body}   req_headers=${请求headers}   timeout=${timeout}   allow_redirects=${重定向}
    ...     expect_status_code=${期待的status code}  expect_resp_headers_contains=${期待的headers包含}
    ...     expect_resp_json=${期待的json body}      expect_resp_body=${期待的body}
    ...     expect_resp_json_contains=${期待的json body包含}    expect_resp_body_contains=${期待的body包含}
    ...     expect_resp_json_regular_expression_contains=${期待的json body正则匹配包含}
    ...     expect_resp_body_regular_expression_contains=${期待的body正则匹配包含}
    ...     expect_resp_json_special_contains=${期待的json body特殊包含}
    [Return]  ${resp}

Supper Http Api Verify
    [Documentation]  包含发送http请求以及简单验证的关键字,暂时不支持上传文件的multipart/form-data和x-www-form-urlencoded。
    ...         第一个参数${method},目前只支持get,post,put,delete,不区分大小写,string类型，必填字段。
    ...         第二个参数是${uri},string类型,必填字段。
    ...         可选参数${params},字典类型，或者可以转成字典的String类型。
    ...         可选参数${request body},string类型。请求body当string处理,这个不要和${request json body}一起用。默认是None。
    ...         可选参数${request json body},字典类型，或者可以转成字典的String类型。当json处理,这个不要和${request body}一起用。默认是None。
    ...         可选参数${request headers},字典类型，或者可以转成字典的String类型。请求头。默认是None。
    ...         可选参数${timeout},int类型,过期时间，单位是秒。默认是None。
    ...         可选参数${allow redirects},bool类型,是否支持重定向。默认是None,如果是None，返回重定向后的结果。
    ...         可选参数${expect status code},int类型。期待的返回status code等于其本身值。默认是None,如果是None，不校验。
    ...         可选参数${expect headers contains},字典类型，或者可以转成字典的String类型。期待的返回headers包含其本身。默认是None,如果是None，不校验。
    ...         可选参数${expect json body},字典类型，或者可以转成字典的String类型。期待返回的response json body与其校验相同,默认是None,如果是None，不校验。
    ...         可选参数${expect body},string类型。期待返回的response body与之校验完全相同,默认是None,如果是None，不校验。
    ...         可选参数${expect json body contains},字典类型，或者可以转成字典的String类型。期待返回的json body包含其本身,默认是None,如果是None，不校验。
    ...         可选参数${expect body contains},string类型。期待返回的response body包含其本身,默认是None,如果是None，不校验。
    ...         可选参数${expect resp json regular expression contains},字典类型,验证response json body的jsonpath下某个值正则匹配，key是jsonpath,value是正则匹配的规则。比如{"$.aa.0.bb":"\d+"}
    ...         可选参数${expect resp body regular expression contains},string类型, 验证response body正则匹配包含。
    ...         可选参数${expect resp json special contains},json类型，或者可以转成json的String类型。默认是None,如果是None，不校验。和${expect json body contains}相比，不同的是针对数组是无序比较包含，目前不支持嵌套数组包含。
    ...         返回response,字典类型。

    [Arguments]      ${method}  ${uri}   ${params}=${None}   ${request body}=${None}   ${request json body}=${None}
    ...     ${request headers}=${None}   ${timeout}=${None}  ${allow redirects}=${None}   ${expect status code}=${None}
    ...     ${expect headers contains}=${None}   ${expect json body}=${None}   ${expect body}=${None}
    ...     ${expect json body contains}=${None}    ${expect body contains}=${None}
    ...     ${expect resp json regular expression contains}=${None}
    ...     ${expect resp body regular expression contains}=${None}
    ...     ${expect resp json special contains}=${None}
    ${resp}=  at one http interface test  ${method}   ${uri}  params=${params}    data=${request body}
    ...      req_json=${request json body}   req_headers=${request headers}   timeout=${timeout}   allow_redirects=${allow redirects}
    ...      expect_status_code=${expect status code}    expect_resp_headers_contains=${expect headers contains}
    ...      expect_resp_json=${expect json body}        expect_resp_body=${expect body}
    ...      expect_resp_json_contains=${expect json body contains}    expect_resp_body_contains=${expect body contains}
    ...      expect_resp_json_regular_expression_contains=${expect resp json regular expression contains}
    ...      expect_resp_body_regular_expression_contains=${expect resp body regular expression contains}
    ...      expect_resp_json_special_contains=${expect resp json special contains}
    [Return]  ${resp}

Mysql运行Sql
    [Documentation]   运行sql。操作查询都可以支持。第一个参数${sql},string类型, 要运行的sql。注意不要用超过2个以上包括2个空格。
    ...   第二个参数${config},字典类型,含有host,port,user,password,db等信息的配置。
    ...   可选参数${期待的影响行数}，int类型。适用于操作数据库的验证，查询的时候此项校验会被忽略。
    ...   可选参数${期待的结果},list类型。验证查询后的数据和期待的数据完全相同。适用于查询数据库的校验，对数据库操作会被忽略，但是日志上会有警告。
    ...   可选参数${期待的结果包含},list或者dict类型。验证查询后的数据包含期待的数据。适用于查询数据库的校验，对数据库操作会被忽略，但是日志上会有警告。
    ...   可选参数${期待没有返回},bool型。就是验证是否返回None。True就是返回结果是None,False则是有数据返回。
    ...   返回结果: 如果是操作数据库，返回int类型,就是影响的行数。如果是查询数据库，如果没有数据返回，返回None。如果有数据返回，返回list类型。
    [Arguments]             ${sql}   ${config}   ${期待的影响行数}=${None}       ${期待的结果}=${None}         ${期待的结果包含}=${None}          ${期待没有返回}=${None}
    ${result}=  at run sql  ${sql}   ${config}   expect_count=${期待的影响行数}  expect_result=${期待的结果}   expect_contains=${期待的结果包含}  should_be_none=${期待没有返回}
    [Return]    ${result}

Mysql Run Sql
    [Documentation]   运行sql。操作查询都可以支持。第一个参数${sql},string类型, 要运行的sql。注意不要用超过2个以上包括2个空格。
    ...   第二个参数${config},字典类型,含有host,port,user,password,db等信息的配置。返回结果: 如果是操作数据库，
    ...   可选参数${expect_count}，int类型。适用于操作数据库的验证，查询的时候此项校验会被忽略。
    ...   可选参数${expect_result},list类型。验证查询后的数据和期待的数据完全相同。适用于查询数据库的校验，对数据库操作会被忽略，但是日志上会有警告。
    ...   可选参数${expect_contains},list或者dict类型。验证查询后的数据包含期待的数据。适用于查询数据库的校验，对数据库操作会被忽略，但是日志上会有警告。
    ...   可选参数${should_be_none},bool型。就是验证是否返回None。True就是返回结果是None,False则是有数据返回。
    ...   返回结果: 如果是操作数据库，返回int类型,就是影响的行数。如果是查询数据库，如果没有数据返回，返回None。如果有数据返回，返回list类型。
    [Arguments]             ${sql}   ${config}  ${expect_count}=${None}        ${expect_result}=${None}        ${expect_contains}=${None}          ${should_be_none}=${None}
    ${result}=  at run sql  ${sql}   ${config}  expect_count=${expect_count}   expect_result=${expect_result}  expect_contains=${expect_contains}  should_be_none=${should_be_none}
    [Return]    ${result}