*** Settings ***
Documentation  对toml文件内容中值的处理的封装。引用请使用Resource  具体代码请参考atApiBasicLibrary/keywords/toml.robot [ sc/toml.html | toml.robot ]
Library  ../tomlLib.py

*** Keywords ***
获取toml文件
    [Documentation]  功能：功能:通过配置文件，把本地文件内容读到配置里，返回配置。
     ...   英文关键字[ ../keywords/toml.doc.html#Get%20toml | Get toml]。
     ...   第一个参数是String类型，文件的路径，注意可以是绝对路径，也可以是相对路径。相对路径是和运行命令的所在当前目录相关。
     ...   返回指定toml文件中的内容, 值是字典类型
     ...   具体代码请参考atApiBasicLibrary/tomlLib.py的 [../library/tomlUtils.py.doc.html#At%20Get%20Toml%20File| at_get_toml_file]方法。
    [Arguments]  ${file_path}
    ${dict} =  at get toml file  ${file_path}
    [Return]  ${dict}

Get toml
    [Documentation]  功能：功能:通过配置文件，把本地文件内容读到配置里，返回配置。
     ...   中文关键字[ ../keywords/toml.doc.html#获取toml文件 | 获取toml文件]。
     ...   第一个参数是String类型，文件的路径，注意可以是绝对路径，也可以是相对路径。相对路径是和运行命令的所在当前目录相关。
     ...   返回指定toml文件中的内容, 值是字典类型
     ...   具体代码请参考atApiBasicLibrary/tomlLib.py的 [../library/tomlUtils.py.doc.html#At%20Get%20Toml%20File| at_get_toml_file]方法。
    [Arguments]  ${file_path}
    ${dict} =  at get toml file  ${file_path}
    [Return]  ${dict}

从toml里取值
    [Documentation]  功能:从配置里读取具体的值。
    ...    英文关键字[ ../keywords/toml.doc.html#Get%20value%20from%20toml | Get value from toml]。
    ...    第一个参数是配置， 字典类型。
    ...    第二个参数是key， String类型。
    ...    返回toml中指定的值，类型可以是list、String、bool等类型。
    ...    具体代码请参考atApiBasicLibrary/tomlLib.py的 [../library/tomlUtils.py.doc.html#At%20Get%20Toml%20Value | at_get_toml_value]方法
    [Arguments]  ${config}   ${key}
    ${val} =  at get toml value  ${config}  ${key}
    [Return]  ${val}

Get value from toml
    [Documentation]  功能:从配置里读取具体的值。
    ...    中文关键字[ ../keywords/toml.doc.html#从toml里取值 | 从toml里取值]。
    ...    第一个参数是配置， 字典类型 。
    ...    第二个参数是key, String类型。
    ...    返回toml中指定的值，类型可以是list、String、bool等类型。
    ...    具体代码请参考atApiBasicLibrary/tomlLib.py的 [../library/tomlUtils.py.doc.html#At%20Get%20Toml%20Value | at_get_toml_value]方法
    [Arguments]  ${config}   ${key}
    ${val} =  at get toml value   ${config}  ${key}
    [Return]  ${val}

从toml文件里取值
    [Documentation]  功能:从配置里读取具体的值。
    ...    英文关键字[ ../keywords/toml.doc.html#Get%20the%20value%20from%20toml%20file | Get the value from toml file]。
    ...    第一个参数是String类型，文件的路径，注意可以是绝对路径，也可以是相对路径。相对路径是和运行命令的所在当前目录相关。。
    ...    第二个参数是key， String类型。
    ...    返回toml中指定的值，类型可以是list、String、bool等类型。
    ...    具体代码请参考atApiBasicLibrary/tomlUtils.py的 [../library/tomlLib.py.doc.html#At%20Get%20Value%20From%20Toml%20File | at_get_value_from_file]方法
    [Arguments]  ${file_path}  ${key}
    ${val} =  at get value from toml file  ${file_path}  ${key}
    [Return]  ${val}

Get the value from toml file
    [Documentation]  功能:从配置里读取具体的值。
    ...    中文关键字[ ../keywords/toml.doc.html#从toml文件里取值 | 从toml文件里取值]。
    ...    第一个参数是String类型，文件的路径，注意可以是绝对路径，也可以是相对路径。相对路径是和运行命令的所在当前目录相关。。
    ...    第二个参数是key， String类型。
    ...    返回toml中指定的值，类型可以是list、String、bool等类型。
    ...    具体代码请参考atApiBasicLibrary/tomlUtils.py的 [../library/tomlLib.py.doc.html#At%20Get%20Value%20From%20Toml%20File | at_get_value_from_toml_file]方法
    [Arguments]  ${file_path}   ${key}
    ${val} =  at get value from toml file  ${file_path}  ${key}
    [Return]  ${val}