*** Settings ***
Documentation  websocket client。发布一次性消息。发布长消息，请直接使用代码级别关键字。
Library  ../websocketLib.py

*** Keywords ***
websocket request
    [Documentation]  发送websocket消息。这是发送一次性消息，就会断连接。第一个参数${url}，是websocket连接地址，string类型
    ...    第二个参数是${msg}，string类型，发送的信息。可选参数${timeout}，单位秒，连接无反应的过期时间。可选参数${header}，
    ...    请求头，列表或者字典类型。
    [Arguments]             ${url}     ${msg}    ${timeout}=${None}   ${header}=${None}
    ${result}=   send msg   ${url}     ${msg}    timeout=${timeout}    header=${header}
    [Return]     ${result}

websocket请求
    [Documentation]  发送websocket消息。这是发送一次性消息，就会断连接。第一个参数${请求地址}，是websocket连接地址，string类型
    ...    第二个参数是${消息}，string类型，发送的信息。可选参数${过期时间}，单位秒，连接无反应的过期时间。可选参数${请求头}，
    ...    请求头，列表或者字典类型。
    [Arguments]             ${请求地址}    ${消息}    ${过期时间}=${None}   ${请求头}=${None}
    ${result}=   send msg   ${请求地址}    ${消息}    timeout=${过期时间}    header=${请求头}
    [Return]     ${result}